<?php
############################
# X-Cart Sitemap v1.3
# Free to use
# Created by Jon Langevin (intel352)
# Email: jon@phpsitesolutions.com
# Web: http://www.phpsitesolutions.com
############################

require "./auth.php";

require $xcart_dir."/include/categories.php";

if ($active_modules["Manufacturers"])
    include $xcart_dir."/modules/Manufacturers/customer_manufacturers.php";

$main = "sitemap";
$smarty->assign("main",$main);

$location[] = array('Sitemap');
$smarty->assign("location", $location);

// Categories
$prod_cnt_query = '
	SELECT
		COUNT(pc.productid)
	FROM
		' . $sql_tbl['products_categories'] . ' pc
	WHERE
		pc.categoryid = c.categoryid
		';

$query = '
	SELECT
		c.categoryid,
		c.category,
		c.parentid,
		(' . $prod_cnt_query . ') AS prod_cnt
	FROM
		' . $sql_tbl['categories'] . ' c
	WHERE
		c.avail="Y"
		';
$tmp_categories = func_query($query);

$sitemap_categories = array();
if($tmp_categories) {
	foreach($tmp_categories AS $sitemap_category) {
		if (!empty($active_modules["XC_SEO"])){
			$sitemap_category['seo_url'] = $seo->_category_callback(array("home.php?cat=".$sitemap_category['categoryid'],false,'','categoryid='.$sitemap_category['categoryid'],'',''), true, $sitemap_category['category']);
		}
		$sitemap_categories[$sitemap_category['categoryid']] = $sitemap_category;
	}
}
unset($tmp_categories);

// Products
$query = '
	SELECT
		p.productid,
		p.product,
		pc.categoryid
	FROM
		' . $sql_tbl['products'] . ' p
		INNER JOIN ' . $sql_tbl['products_categories'] . ' pc ON (p.productid = pc.productid)
	WHERE
		p.forsale="Y"
		';
$sitemap_products = func_query($query);

if($sitemap_products) {
	foreach($sitemap_products AS $sitemap_product) {
		if (!empty($active_modules["XC_SEO"])){
			$sitemap_product['seo_url'] = $seo->_product_callback(array("product.php?productid=".$sitemap_product['productid'],false,'','productid='.$sitemap_product['productid'],'',''), true, $sitemap_product['product']);
		}
		if(isset($sitemap_categories[$sitemap_product['categoryid']]))
			$sitemap_categories[$sitemap_product['categoryid']]['products'][] = $sitemap_product;
	}
}
unset($sitemap_products);

if($sitemap_categories) {
	$sitemap_categories = sitemap_category_tree($sitemap_categories);
}

// Static Pages
$query = '
	SELECT
		p.pageid,
		p.title
	FROM
		' . $sql_tbl['pages'] . ' p
	WHERE
		p.active="Y"
		AND p.filename NOT IN ("index.html","shop_closed.html")
		';
$sitemap_pages = func_query($query);

if ($sitemap_pages && !empty($active_modules["XC_SEO"])){
	foreach($sitemap_pages AS $k=>$sitemap_page) {
		$sitemap_pages[$k]['seo_url'] = $seo->_pages_callback(array("pages.php?pageid=".$sitemap_page['pageid'],false,'','pageid='.$sitemap_page['pageid'],'',''), true, $sitemap_page['title']);
	}
}

$smarty->assign('products_per_page', $config["Appearance"]["products_per_page"]);

$smarty->assign('sitemap_categories', $sitemap_categories);
$smarty->assign('sitemap_pages', $sitemap_pages);

func_display("customer/home.tpl",$smarty);

exit;

function sitemap_category_tree($sitemap_categories, $current=0) {
	$returnArr = array();
	foreach ($sitemap_categories as $catid => $sitemap_category) {
		$parentArr =& $returnArr;
		if($sitemap_category['parentid'] == $current) {
			$parentArr[$catid] = $sitemap_category;
			$parentArr[$catid]['subcategories'] = sitemap_category_tree($sitemap_categories, $catid);
		}
	}
	unset($sitemap_categories);
	return $returnArr;
}

?>